#include "tricks.h"
#include <stdio.h>

byte Texture[256*256];
byte pal[256][3];

int holex[320][200];
int holey[320][200];

void load( char *file, byte *data, unsigned int length );
void loadpal( char *file );

void main()
{
   load( "wormhole.raw", Texture, 256*256 );
   loadpal( "wormhole.pal" );

   GrabPallette();
   SetMCGA();

   for( int i=0; i<256; i++ )
      Pal(i, pal[i][0], pal[i][1], pal[i][2] );

   Pal(0,0,0,0);

   for( float v=0; v< 2*PI; v += 2*PI/2000)
      for( float z=0.01; z<1; z += 0.005 )
      {
         unsigned int x = cos(v)*z * 200 + 160;
         unsigned int y = sin(v)*z * 200 + 100;

         if( x<320 && y<200 )
         {
            holex[x][y] = int((v*512)/(2*PI))&0xff;
            holey[x][y] = int(30/z)&0xff;

            vga[x+y*320] = Texture[ holex[x][y] + holey[x][y] * 256 ];    
         }

         if(kbhit()) return;
      }

   int f = 0;

   while (!kbhit())
   {     
      for( int x=0; x<320; x++)
         for( int y=0; y<200; y++ )
            vga[x+(y<<6)+(y<<8)] = Texture[ ((holex[x][y]+f)&0xff) + ((holey[x][y]+f)&0xff00) ];    

      f++;

      WaitRetrace();
   }

   getch();

   RestorePallette();
   SetText();
}


void load( char *file, byte *data, unsigned int length )
{
   FILE *fp = fopen( file, "rb" );

   if( ferror( fp ) )
   {
      printf("Error opening %s\n", file);
		exit( EXIT_FAILURE );
   }

   fread( data, 1, length, fp);

   if( ferror( fp ) )
   {
      printf("Error reading %s\n", file);
		exit( EXIT_FAILURE );
   }

   fclose( fp );
}

void loadpal( char *file )
{
   FILE *fp = fopen( file, "r" );

   if( ferror( fp ) )
   {
      printf("Error opening %s\n", file);
		exit( EXIT_FAILURE );
   }

   for( int i=0; i<256; i++)
   {
      int r,g,b;

      fscanf( fp, "%d %d %d", &r,&g,&b);

      pal[i][0] = r>>2;
      pal[i][1] = g>>2;
      pal[i][2] = b>>2;
   }

   if( ferror( fp ) )
   {
      printf("Error reading %s\n", file);
		exit( EXIT_FAILURE );
   }

   fclose( fp );
}

